﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;

using System.Windows.Data;
namespace silverLife
{
    public partial class MainPage : UserControl
    {
        const int GridSize = 20;
        private Cell[,] cells = new Cell[GridSize, GridSize];
        private System.Windows.Threading.DispatcherTimer timer=new System.Windows.Threading.DispatcherTimer();
      
        private int[,] n = new int[GridSize, GridSize];
       
        public MainPage()
        {
            InitializeComponent();
            for (int i = 0; i < GridSize; i++)
            {
                grid1.ColumnDefinitions.Add(new ColumnDefinition());
                grid1.RowDefinitions.Add(new RowDefinition());
            }

            for (int i = 0; i < GridSize; i++)
            {
                for (int j = 0; j < GridSize; j++)
                {

                    Ellipse el = new Ellipse();
                    cells[i, j] = new Cell { state = false };
                   
                    Grid.SetColumn(el, j);
                    Grid.SetRow(el, i);
                    el.Fill = new SolidColorBrush(Colors.Red);

                    el.DataContext = cells[i, j];
                    el.SetBinding(OpacityProperty,new Binding( "state"));

                    grid1.Children.Add(el);

                }


            }
            setupTimer();

        }


        private void TimerProc(object o,EventArgs e)
        {
            counter();
            nextgen();
        }



        private void setupTimer()
        {
            timer.Interval = new TimeSpan(0, 0, 0, 0, 200);
            timer.Tick += (obj, evnt) =>
                {
                    counter();
                    nextgen();
                };
        }

        private void counter()
        {
            for (int i = 1; i < GridSize - 1; i++)
            {
                for (int j = 1; j < GridSize - 1; j++)
                {
                    n[i, j] = cells[i - 1, j] + cells[i + 1, j] + cells[i, j - 1] + cells[i, j + 1];
                    n[i, j] += cells[i - 1, j - 1] + cells[i + 1, j - 1] + cells[i + 1, j + 1] + cells[i - 1, j + 1];
                }
            }
        }

        private void nextgen()
        {
            for (int i = 1; i < GridSize - 1; i++)
            {
                for (int j = 1; j < GridSize - 1; j++)
                {
                    if (n[i, j] == 3) cells[i, j].state = true;
                    if (n[i, j] >= 4) cells[i, j].state = false;
                    if (n[i, j] <= 1) cells[i, j].state = false;

                }
            }
        }


        private void grid1_MouseLeftButtonDown_1(object sender, MouseButtonEventArgs e)
        {
            if (e.OriginalSource is Ellipse)
            {
                Ellipse temp = ((Ellipse)e.OriginalSource);
                Cell C = (Cell)temp.DataContext;
                C.state = !C.state;
            }

        }

        private void button1_Click_1(object sender, RoutedEventArgs e)
        {
            if (button1.Content.ToString() == "Run")
            {
                button1.Content = "Stop";
                  timer.Start();
            }
            else
            {
                button1.Content = "Run";
                timer.Stop();

            }
        }

        public class Cell : INotifyPropertyChanged
        {
            private bool _state;
            public event PropertyChangedEventHandler PropertyChanged;
            public bool state
            {
                get
                {
                    return _state;
                }
                set
                {
                    _state = value;
                    if (PropertyChanged != null)
                    {
                        this.PropertyChanged(this, new PropertyChangedEventArgs("state"));
                    };

                }
            }
            public static implicit operator int(Cell c)
            {
                return Convert.ToInt32(c.state);
            }
        }

    }
}

